10.3【A】

32

如果子串是有效的,那么最终必定以右括号为结尾

暴力法

好的方法暂时想不出来,先考虑暴力法,即假设以每个字符为起点开始向后延申,最后取MAX;并辅以各种剪枝

首先是起始必须是左括号

然后左括号数量不能超过给定字符串s长度的一半,进一步地,应该是从此字符开始时,剩余字符串长度的一半

然后右括号数量不能超过左括号

当子串的左右括号数量相等时,就尝试更新一次结果

每个起始位置结束的标志就是左括号数量超过剩余的一半,或者右括号数量超过左括号数量

没想到直接过了

这里需要注意左括号数量打到一半时,这个剩余子串的长度,应该是要包含起始子串自身的

即应该是n-i,而不是n-i-1

如果以下标i为开始的子串,那么在其前面是有i个元素

总共元素是有n个,那么算上起点,剩余的就是n-i个

如果不算上起点,那就是n-i-1个

这个优化就是说不需要cur,因为已经知道起点和有效时的终点,那么直接算就行

栈法

为什么弹出后栈为空,则当前的右括号是多余的?他不是和刚从栈顶弹出的这个左括号所匹配了吗?

到这里就和滑动窗口差不多了,就是用一个垫底哨兵了解释右括号是否还能继续加入,以及标识下个可能有效的合法子串的起始位置是哪里(但这个一定用不上,因为合法子串一定以右括号为结尾,那么与之对应的起始位置一定是栈里合法的未匹配左括号的下标)

那就是滑动窗口,只不过是以栈来维护的滑动窗口

当遇到左括号时,就将其下标加入到栈中

遇到右括号时,看是否能和它匹配,如果能就尝试更新

否则就过

就是说遇到右括号时,不应当直接与其对应的左括号做匹配,而是要利用其下标去找到合法子串开始时的那个下标,来定位出整个合法子串的长度

那这个就需要去记录合法字串开始时的那个不合法位置在哪

如果右括号本身不合法,那就需要令其自身作为栈底

否则就需要尝试去看与之匹配的左括号下面一个是什么,如果是栈底,那就说明连续上了,如果不是,说明还有没匹配完的左括号,

然后对于数值的计算,st.top()是不合法的位置,st.top()+1是合法的起点,那么整体的长度就是i-(st.top()+1)+1,即i-st.top()

相关推荐
言乐62 小时前
Python区分广度优先深度优先宽度优先的区别
python·算法·深度优先·广度优先·宽度优先
RobinDevNotes1 天前
大模型3D并行训练怎么配才不浪费算力
网络·人工智能·深度学习·深度优先
一条大祥脚1 天前
26 ICPC上海 交互|二分|重心|构造|二分图|贪心|SOSDP|三进制枚举|线性基|字典序贪心|DFS|分块|单侧递归线段树
算法·深度优先·交互·分块·icpc上海站·单侧递归线段树
CQU_JIAKE4 天前
9.29【A】
算法·深度优先
longlongzihan5 天前
LeetCode 17电话号码的字母组合:回溯算法(DFS)详解
c++·算法·leetcode·深度优先
Because_of_Her15 天前
dfs-洪水填充技巧
笔记·算法·深度优先·洪水填充
Coder-magician6 天前
《代码随想录》刷题打卡day44:图论-part02
算法·深度优先·图论
aqiu1111116 天前
【蓝桥杯】0仙境诅咒 — BFS/DFS 图论连通性问题(C++ 题解)
蓝桥杯·深度优先·宽度优先
专注仿真7 天前
ACM算法
算法·深度优先